#ifndef CFORMATxH
#define CFORMATxH

#define  STDERR   stderr

typedef unsigned char Byte;

struct disk_info {
   int   bytes_per_sector;
   Byte  sectors_per_cluster;
   int   reserved_sectors;
   Byte  FATs;
   int   root_directories;
   int   total_sectors;
   Byte  media_descriptor;
   int   sectors_per_FAT;
   int   sectors_per_track;
   int   heads;
};

struct boot_sector {
   Byte jmp[3];
   char OEMname[8];
   struct disk_info parms;
   long hidden_sectors;             /* only used for largish fixed disks */
   long sectors_in_logical_volume;  /* only used for largish fixed disks */
   Byte drive_number;
   Byte reserved;
   Byte extended_boot_signature;
   long serial_number;
   char label[11];
   char FAT_type[8];
};

struct validity {
   char OK;
   char disk_type_code;
};

int  reset(int drive);
int  setdisktype(int drive, int type);
int  setmediatype(int drive, int ntracks, int nsects);
int  format(int drive, int head, int track, int nsects, struct disk_info* info);
int  verify(int drive, int head, int track, int nsects);
int  write_hts(int drive, int head, int track, int sect, int nsects, Byte* buf);
int  write_boot(int drive, struct disk_info* info);
long serial_number(void);
int  write_sector(int drive, int sector, Byte* buf, struct disk_info* info);
int  write_FATs(int drive, struct disk_info* info);
int  write_root(int drive, struct disk_info* info);
int  write_system(int drive);
int  copy_file(char* dest, char* src);
void cleanup(void);
int  breakhandler(void);
int  errhandler(void);
int  getdrivetype(int drive);

#endif
